<script>
export default {
    props: {
        path: {
            type: String,
            default: "edit",
        },
        item: {
            type: [Array, Object],
            default: () => [],
        },
    },
    data() {
        return {
            finish: false,
            maxLength: 400,
        };
    },
    methods: {
        checkSize(e) {
            if (e.which != 8 && e.target.textContent.length >= this.maxLength) {
                e.preventDefault();
            }
        },
        handleComposition(boolean) {
            this.finish = boolean;
        },
    },
    render(h) {
        let vm = this;
        let env = vm.path == "edit";
        let data = (key, text) => {
            return {
                class: ["text_content", `text_${key}`],
                attrs: {
                    contentEditable: env ? true : false,
                    placeholder: text,
                },
                on: {
                    input(e) {
                        if (e && e.target && e.target.textContent) {
                            if (e.target.textContent <= vm.maxLength) {
                                console.log("e.target.textContent <= vm.maxLength");
                                vm.$emit("change", e.target.textContent);
                            } else {
                                setTimeout(function () {
                                    if (vm.finish) {
                                        let r = $(vm.$el)
                                            .find(`.text_${key}`)
                                            .text()
                                            .substring(0, vm.maxLength);
                                        $(vm.$el).find(`text_${key}`).text(r);

                                        vm.$el.blur();
                                    }
                                }, 500);
                            }
                        }
                    },
                    blur(e) {
                        vm.$store.commit("UPDATE_SECONDARYCOMPONENT_VALUE", {
                            key: vm.item.id,
                            second_key: key,
                            val: e.target.textContent,
                        });
                    },
                    keypress(e) {
                        vm.checkSize(e);

                        if (e.keyCode === 13) {}
                    },
                    paste(e) {
                        vm.checkSize(e);
                    },
                    compositionStart(e) {
                        vm.handleComposition(false);
                    },
                    compositionend(e) {
                        vm.handleComposition(true);
                    },
                },
            };
        };

        let res = h(
            "div", {
                attrs: {
                    id: "textEdit",
                },
                style: {
                    height: "auto",
                },
            },
            [
                h("div", {}, [
                    h("h1", data("title", "測試標題"), [this.item.content.title]),
                    h(
                        "p",
                        data("sub", "這個內容是測試使用，請點擊編輯後，修改為您的內容。"),
                        [this.item.content.sub]
                    ),
                ]),
            ]
        );

        return res;
    },
};
</script>

<style lang="scss">
.text_content:empty:before {
    content: attr(placeholder);
    color: #a5a5a9;
}

.text_content:focus:before {
    content: none;
}
</style>
